#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2700four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 2700"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2700four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four27004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2four27004xi = {
                1:'1009x-242y2492z',
                2:'1044x-896y2322z',
                3:'1045x-194y2481z',
                4:'1072x-1407y2039z',
                5:'1078x-142y2470z',
                6:'1082x-2432y449z',
                7:'1101x-1815y1668z',
                8:'1108x-854y2309z',
                9:'1109x-87y2459z',
                10:'1137x-30y2448z',
                11:'1157x-1365y2021z',
                12:'1170x-808y2294z',
                13:'1204x-1768y1646z',
                14:'1210x-2376y422z',
                15:'1230x-757y2280z',
                16:'1241x-1317y2003z',
                17:'1288x-703y2266z',
                18:'1304x-1716y1625z',
                19:'1323x-1264y1985z',
                20:'1335x-2312y395z',
                21:'1343x-644y2251z',
                22:'137x-2620y634z',
                23:'1396x-582y2236z',
                24:'1402x-1206y1966z',
                25:'1403x-1657y1603z',
                26:'1446x-515y2220z',
                27:'1456x-2243y369z',
                28:'1479x-1143y1948z',
                29:'1492x-445y2205z',
                30:'1499x-1593y1581z',
                31:'1534x-372y2189z',
                32:'1552x-1075y1929z',
                33:'1573x-295y2173z',
                34:'1574x-2166y342z',
                35:'1591x-1524y1559z',
                36:'1608x-215y2157z',
                37:'160x-122y2692z',
                38:'1623x-1002y1910z',
                39:'1639x-132y2141z',
                40:'1665x-47y2124z',
                41:'1681x-1448y1537z',
                42:'1687x-2083y315z',
                43:'1690x-925y1891z',
                44:'1753x-844y1871z',
                45:'1766x-1368y1515z',
                46:'1796x-1994y288z',
                47:'1812x-758y1852z',
                48:'183x-517y2643z',
                49:'1848x-1282y1493z',
                50:'1866x-668y1832z',
                51:'188x-129y2690z',
                52:'1900x-1900y262z',
                53:'1916x-575y1812z',
                54:'1925x-1191y1470z',
                55:'1961x-478y1792z',
                56:'1998x-1096y1447z',
                57:'1998x-1799y235z',
                58:'2001x-378y1772z',
                59:'2036x-275y1751z',
                60:'2065x-169y1731z',
                61:'2065x-996y1424z',
                62:'2088x-62y1710z',
                63:'2092x-1694y208z',
                64:'2127x-892y1401z',
                65:'2179x-1583y181z',
                66:'218x-133y2687z',
                67:'220x-531y2637z',
                68:'2260x-1468y154z',
                69:'2265x-813y1429z',
                70:'2335x-1348y127z',
                71:'2404x-1224y100z',
                72:'2465x-1097y73z',
                73:'248x-134y2685z',
                74:'2520x-967y46z',
                75:'2567x-834y19z',
                76:'258x-543y2632z',
                77:'274x-2616y608z',
                78:'279x-132y2682z',
                79:'299x-552y2625z',
                80:'310x-128y2678z',
                81:'341x-558y2619z',
                82:'342x-120y2675z',
                83:'373x-109y2671z',
                84:'385x-561y2612z',
                85:'405x-96y2667z',
                86:'412x-2604y581z',
                87:'430x-560y2605z',
                88:'435x-79y2663z',
                89:'442x-1074y2437z',
                90:'465x-60y2658z',
                91:'475x-557y2598z',
                92:'494x-37y2654z',
                93:'508x-1071y2425z',
                94:'522x-12y2648z',
                95:'522x-550y2591z',
                96:'549x-2584y555z',
                97:'568x-540y2583z',
                98:'575x-1064y2413z',
                99:'616x-526y2575z',
                100:'642x-1053y2401z',
                101:'663x-509y2567z',
                102:'685x-2557y528z',
                103:'709x-488y2558z',
                104:'710x-1038y2388z',
                105:'720x-1525y2108z',
                106:'756x-463y2550z',
                107:'778x-1019y2376z',
                108:'801x-435y2541z',
                109:'809x-1503y2091z',
                110:'819x-2522y502z',
                111:'845x-994y2363z',
                112:'846x-404y2531z',
                113:'889x-369y2522z',
                114:'897x-1477y2074z',
                115:'912x-966y2349z',
                116:'931x-330y2512z',
                117:'952x-2481y475z',
                118:'971x-288y2502z',
                119:'979x-933y2336z',
                120:'985x-1445y2056z',
                121:'996x-1855y1689z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2700four4xi" usage = "target function for charge27004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2700four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2700FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2700FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2700FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2700FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2700FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four27004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2700FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2700FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2700FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four27004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four27004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2700FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2700FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2700FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2700four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                    